//+------------------------------------------------------------------+
//|                                                           rsiSS  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers    4
#property indicator_color1     clrLimeGreen
#property indicator_color2     clrOrange
#property indicator_color3     clrOrange
#property indicator_color4     clrYellow
#property indicator_width1     2
#property indicator_width2     2
#property indicator_width3     2
#property indicator_style4     STYLE_DASHDOT
#property strict

//
//
//
//
//

enum prices
{
   pr_close,   // Close
   pr_open,    // Open
   pr_high,    // High
   pr_low,     // Low
   pr_median,  // Median
   pr_typical, // Typical
   pr_weighted // Weighted
};
enum maTypes
{
   ma_sma,  // Simple moving average
   ma_ema,  // Exponential moving average
   ma_smma, // Smoothed moving average
   ma_lwma  // Linear weighted moving average
};

extern string  TimeFrame          = "Current time frame"; // Time frame to use
extern int     RsiSS_Period       = 32;                   // Rsi period
extern prices  RsiSS_Price        = pr_close;             // Price to use
extern int     MaPeriod           = 9;                    // Signal period
extern maTypes MaType             = ma_lwma;              // Signal type
extern bool    ColorOnSlope       = true;                 // Change color on slope change?
extern double  levelOb            = 80;                   // Upper level
extern double  levelOs            = 20;                   // Lower level
extern bool    alertsOn           = false;                // Turn alerts on?
extern bool    alertsOnSlope      = false;                // Alert on slope change?
extern bool    alertsOnCurrent    = true;                 // Alert on current (still opened) bar?
extern bool    alertsMessage      = true;                 // Alert using pop-up message
extern bool    alertsSound        = false;                // Alert using sound?
extern bool    alertsEmail        = false;                // Alert using email?
extern bool    alertsNotification = false;                // Alert using push notification?
extern bool    Interpolate        = true;                 // Interpolate in multi time frame mode?

//
//
//
//
//

double rsi[];
double rsida[];
double rsidb[];
double ma[];
double mab[];
double trend[];
double slope[];

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
  IndicatorBuffers(7);
    SetIndexBuffer(0,rsi);
    SetIndexBuffer(1,rsida);
    SetIndexBuffer(2,rsidb);
    SetIndexBuffer(3,ma);
    SetIndexBuffer(4,mab);
    SetIndexBuffer(5,trend);
    SetIndexBuffer(6,slope);
      SetLevelValue(0,levelOs);
      SetLevelValue(1,levelOb);
    
      //
      //
      //
      //
      //
     
      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
 
      IndicatorShortName(timeFrameToString(timeFrame)+" rsi super smoother ("+(string)RsiSS_Period+","+(string)MaPeriod+")");
   return(0);
}
int deinit() {  return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { rsi[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame==Period())
   {
      if (ColorOnSlope)
            if (slope[limit] == -1) ClearPoint(limit,rsida,rsidb);
      else  if (trend[limit] == -1) ClearPoint(limit,rsida,rsidb);
      for (i=limit; i >= 0; i--) mab[i] = iSsm(iMA(NULL,0,1,0,MODE_SMA,(int)RsiSS_Price,i),RsiSS_Period,i,0);
      for (i=limit; i >= 0; i--) rsi[i] = iRSIOnArray(mab,0,RsiSS_Period,i);
      for (i=limit; i >= 0; i--)
      {
        ma[i] = iMAOnArray(rsi,0,MaPeriod,0,(int)MaType,i);
        rsida[i] = EMPTY_VALUE;
        rsidb[i] = EMPTY_VALUE;
        if (i<Bars-1)
        {
            slope[i] = slope[i+1];
            trend[i] = trend[i+1]; 
         
	         if (rsi[i] > rsi[i+1]) slope[i]= 1; 
	         if (rsi[i] < rsi[i+1]) slope[i]=-1;
	         if (rsi[i] > ma[i])    trend[i]= 1; 
	         if (rsi[i] < ma[i])    trend[i]=-1;
	         if (ColorOnSlope)
	               { if (slope[i] == -1) PlotPoint(i,rsida,rsidb,rsi); }
            else	{ if (trend[i] == -1) PlotPoint(i,rsida,rsidb,rsi); }
         }	       
      }
      manageAlerts();  
      return(0);
    }
    
    //
    //
    //
    //
    //

    limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
    if (ColorOnSlope)
          if (slope[limit] == -1) ClearPoint(limit,rsida,rsidb);
    else  if (trend[limit] == -1) ClearPoint(limit,rsida,rsidb);
    for (i=limit; i>=0; i--)
    {
       int y = iBarShift(NULL,timeFrame,Time[i]);
            rsi[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsiSS_Period,RsiSS_Price,MaPeriod,MaType,ColorOnSlope,levelOb,levelOs,alertsOn,alertsOnSlope,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsNotification,0,y);
            rsida[i] = EMPTY_VALUE;
            rsidb[i] = EMPTY_VALUE;
            ma[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsiSS_Period,RsiSS_Price,MaPeriod,MaType,ColorOnSlope,levelOb,levelOs,alertsOn,alertsOnSlope,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsNotification,3,y);
            trend[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsiSS_Period,RsiSS_Price,MaPeriod,MaType,ColorOnSlope,levelOb,levelOs,alertsOn,alertsOnSlope,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsNotification,5,y);
            slope[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",RsiSS_Period,RsiSS_Price,MaPeriod,MaType,ColorOnSlope,levelOb,levelOs,alertsOn,alertsOnSlope,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsNotification,6,y);
            
            //
            //
            //
            //
            //

            if (!Interpolate || ((i>0) && y==iBarShift(NULL,timeFrame,Time[i-1]))) continue;
               datetime time = iTime(NULL,timeFrame,y);
               int n,x;
                  for(n = 1; (i+n)<(Bars-1) && Time[i+n] >= time; n++) continue;	
                  for(x = 1; x < n && (i+x)<Bars; x++)
                  {
                     rsi[i+x] = rsi[i] + (rsi[i+n] - rsi[i]) * x/n;
                     ma[i+x]  = ma[i]  + (ma[i+n]  - ma[i])  * x/n;
                  }                   
    }  
    for (i=MathMin(limit,Bars-3); i>=0; i--)
	         if (ColorOnSlope)
	               { if (slope[i] == -1) PlotPoint(i,rsida,rsidb,rsi); }
            else	{ if (trend[i] == -1) PlotPoint(i,rsida,rsidb,rsi); }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workSsm[][2];
#define _price  0
#define _ssm    1

double workSsmCoeffs[][4];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define Pi 3.14159265358979323846264338327950288

//
//
//
//
//

double iSsm(double price, double period, int i, int instanceNo)
{
   if (ArrayRange(workSsm,0) !=Bars)                 ArrayResize(workSsm,Bars);
   if (ArrayRange(workSsmCoeffs,0) < (instanceNo+1)) ArrayResize(workSsmCoeffs,instanceNo+1);
   if (workSsmCoeffs[instanceNo][_period] != period)
   {
      workSsmCoeffs[instanceNo][_period] = period;
      double a1 = MathExp(-1.414*Pi/period);
      double b1 = 2.0*a1*MathCos(1.414*Pi/period);
         workSsmCoeffs[instanceNo][_c2] = b1;
         workSsmCoeffs[instanceNo][_c3] = -a1*a1;
         workSsmCoeffs[instanceNo][_c1] = 1.0 - workSsmCoeffs[instanceNo][_c2] - workSsmCoeffs[instanceNo][_c3];
   }

   //
   //
   //
   //
   //

      i = Bars-i-1;
      int s = instanceNo*2;   
          workSsm[i][s+_price] = price;
          if (i>2)
            workSsm[i][s+_ssm] = workSsmCoeffs[instanceNo][_c1]*(workSsm[i][s+_price]+workSsm[i-1][s+_price])/2.0 + 
                                 workSsmCoeffs[instanceNo][_c2]*workSsm[i-1][s+_ssm]                              + 
                                 workSsmCoeffs[instanceNo][_c3]*workSsm[i-2][s+_ssm];
          else workSsm[i][s+_ssm] = price;
   return(workSsm[i][s+_ssm]);
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,120,60,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   StringToUpper(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+(string)iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                              return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void ClearPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
   {
      if (first[i+2] == EMPTY_VALUE) 
      {
          first[i]    = from[i];
          first[i+1]  = from[i+1];
          second[i]   = EMPTY_VALUE;
      }
      else
      {
          second[i]   = from[i];
          second[i+1] = from[i+1];
          first[i]    = EMPTY_VALUE;
      }
   }
   else
   {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
      
      //
      //
      //
      //
      //
      
      if (alertsOnSlope)
      {
         if (slope[whichBar] != slope[whichBar+1])
         {
            if (slope[whichBar] == 1) doAlert(whichBar,"slope changed to up");
            if (slope[whichBar] ==-1) doAlert(whichBar,"slope changed to down");
         }         
      }
      else
      {
         if (trend[whichBar] != trend[whichBar+1])
         {
            if (trend[whichBar] == 1) doAlert(whichBar,"crossed ma line up");
            if (trend[whichBar] ==-1) doAlert(whichBar,"crossed ma line down");
         }         
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(Period())," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Rsi super smooth ",doWhat);
             if (alertsMessage)      Alert(message);
             if (alertsEmail)        SendMail(StringConcatenate(Symbol()," Rsi super smooth"),message);
             if (alertsNotification) SendNotification(StringConcatenate(Symbol()," Rsi super smooth ",message));
             if (alertsSound)        PlaySound("alert2.wav");
      }
}